//+------------------------------------------------------------------+
//|                                             MultiScreenShot.mq4  |
//+------------------------------------------------------------------+

#import "user32.dll"
int GetParent(int hWnd);

#include <WinUser32.mqh>

int P;
int hwnd;
string ImageName;

int PTimeFrame[] = {1,5,15,30,60,240,1440,10080,43200};
string PTimeFrameDescriptionShort[] = {"1Min","5Min","15Min","30Min","1H","4H","Daily","Weekly","Monthly"};

void start()
{
   P = Period(); //Current Timeframe
  
   //The following will toggle through all of the possible Timeframes.
   for(int j = 0;j < ArraySize(PTimeFrame);j++)
   {
      hwnd = WindowHandle( Symbol(), P);
      
      //Only do something with the Timeframe if it exists for the given profile.
      if (hwnd > 0)
      {
         Window.activate(hwnd);
         Window.maximize(hwnd);

         //For demonstration only, show the screen "working" through the different timeframes.
         Sleep(1000);

         ImageName = StringConcatenate(Symbol(),"_",
                                       PTimeFrameDescriptionShort[ArrayBsearch(PTimeFrame,P)],".gif");

         WindowScreenShot("shots\\"+ImageName,640,480,-1,-1,CHART_CANDLE );

         //Get Next Timeframe
         P = getNextTimeframe(P);
      }
   }

}

//+---------------------------------------------------------------------+
//+                                                                     +
//+   getNextTimeframe                                                  +
//+                                                                     +
//+   Identify the higher timeframe for a given timeframe               +
//+                                                                     +
//+---------------------------------------------------------------------+
int getNextTimeframe(int TimeFrame)
{
   int NextTF, TFMaxPos, TFPos;
   
   TFMaxPos = ArraySize(PTimeFrame) - 1;
   TFPos = ArrayBsearch(PTimeFrame,TimeFrame);
   
   //Are we currently on the last element in the Time Frame Array
   if (TFPos == TFMaxPos)
      return(-1);
   
   NextTF = PTimeFrame[TFPos + 1];

   return(NextTF);
}

//+-------------------------------------------------------------------------------+

int Window.activate(int hwnd) {
   int p = GetParent(hwnd);
   SendMessageA(GetParent(p), WM_MDIACTIVATE, p, 0);
}
int Window.maximize(int hwnd) {
   int p = GetParent(hwnd);
   SendMessageA(GetParent(p), WM_MDIMAXIMIZE, p, 0);
}